# Does review apps, etc. Integrate dast
include:
  - template: DAST.latest.gitlab-ci.yml
  - template: Dependency-Scanning.gitlab-ci.yml
  - template: Workflows/Branch-Pipelines.gitlab-ci.yml
  - template: Container-Scanning.gitlab-ci.yml
  - template: API-Fuzzing.gitlab-ci.yml
  - template: Security/License-Scanning.gitlab-ci.yml
  - template: Coverage-Fuzzing.gitlab-ci.yml

stages:
  - dump
  - docker_build
  - test
  - deploy
  - fuzz
  - dast
  - stop

variables:
  KUBE_NAMESPACE: dast-project
  VERIFY_CHECKSUM: "false"
  FUZZAPI_PROFILE: Quick-10
  FUZZAPI_OPENAPI: test-api-specification.json

license_scanning:
  before_script:
    - sudo apt-get update
    - sudo apt-get install wget
    - wget https://packages.microsoft.com/config/ubuntu/20.10/packages-microsoft-prod.deb -O packages-microsoft-prod.deb
    - sudo dpkg -i packages-microsoft-prod.deb
    - sudo apt-get update
    - |
      sudo apt-get install -y apt-transport-https
      sudo apt-get update
      sudo apt-get install -y dotnet-sdk-5.0
  artifacts:
    reports:
      license_scanning: gl-license-scanning-report.json

.review_stage_common_script: &review_stage_common_script
  - wget -O get_helm.sh https://raw.githubusercontent.com/helm/helm/master/scripts/get-helm-3
  - chmod 700 get_helm.sh
  - ./get_helm.sh
  - helm repo add bitnami https://charts.bitnami.com/bitnami
  - apk add jq

.review_stage_common:
  image: registry.gitlab.com/gitlab-org/cluster-integration/cluster-applications:v0.40.0
  stage: deploy

docker_build:
  stage: docker_build
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/Dockerfile --destination $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA

deploy_review:
  extends: .review_stage_common
  script:
    - *review_stage_common_script
    - helm install my-release-$CI_COMMIT_SHORT_SHA bitnami/apache
    - DYNAMIC_ENVIRONMENT_URL=""
    - while [ -z $DYNAMIC_ENVIRONMENT_URL ]; do
    -   DYNAMIC_ENVIRONMENT_URL=$(kubectl get svc --namespace $KUBE_NAMESPACE my-release-$CI_COMMIT_SHORT_SHA-apache -o json | jq '. | select(.status.loadBalancer.ingress[0].hostname != null) | .status.loadBalancer.ingress[0].hostname')
    - done
    - echo "IP is $DYNAMIC_ENVIRONMENT_URL and nothing more"
    - DYNAMIC_ENVIRONMENT_URL=$(echo $DYNAMIC_ENVIRONMENT_URL | tr -d '"')
    - DYNAMIC_ENVIRONMENT_URL=http://${DYNAMIC_ENVIRONMENT_URL}
    - echo "Full URL is $DYNAMIC_ENVIRONMENT_URL"
    - echo "DYNAMIC_ENVIRONMENT_URL=$DYNAMIC_ENVIRONMENT_URL" >> deploy.env
    - echo "$DYNAMIC_ENVIRONMENT_URL" >> environment_url.txt
    - echo "FUZZAPI_TARGET_URL=$DYNAMIC_ENVIRONMENT_URL" >> deploy.env
    - more deploy.env
    - more environment_url.txt
  artifacts:
    reports:
      dotenv: deploy.env
    paths: [environment_url.txt]
    when: always
  environment:
    name: review/$CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA
    url: $DYNAMIC_ENVIRONMENT_URL
    kubernetes:
      namespace: $KUBE_NAMESPACE
    on_stop: stop_review
    auto_stop_in: 1 week

stop_review:
  extends: .review_stage_common
  stage: stop
  script:
    - *review_stage_common_script
    - helm uninstall my-release-$CI_COMMIT_SHORT_SHA
  environment:
    name: review/$CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA
    kubernetes:
      namespace: $KUBE_NAMESPACE
    action: stop
  rules:
    - when: manual
